<?php
/*****************************************************************************\
 *  spip-rewrite-with-404                                                    *
 *                                                                           *
 *  Copyright (c) 2007                                                       *
 *  Boris Lechner - boris.lechner@gmail.com                                  *
 *                                                                           *
 *  Version 1.2 - 2007/05/06                                                 *
 *                                                                           *
 *  This program is free software; you can redistribute it and/or modify     *
 *  it under the terms of the GNU General Public License as published by     *
 *  the Free Software Foundation; either version 2 of the License, or        *
 *  (at your option) any later version.                                      *
 *                                                                           *
 *  This program is distributed in the hope that it will be useful,          *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
 *  GNU General Public License for more details.                             *
 *                                                                           *
 *  You should have received a copy of the GNU General Public License        *
 *  along with this program; if not, write to the Free Software              *
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA *
\*****************************************************************************/

class SpipRewriteWith404 {
	// Initialisation des variables utilisées dans la classe
	var $installdir;
	var $regles;
	var $url;
	var $qsa;
	var $pagedestination;
	
	function SpipRewriteWith404() {
		##################################################################
		# La configuration du script commence sous cette ligne

		###
		# Le prefixe de l'adresse (doit au minimum être / et doit toujours se finir par un /)
		# Attention, c'est un filtre d'expression rationnelle, certains caracteres non alphanumériques doivent être échapés
		# Consultez la documentation de la fonction php "preg_replace" pour en savoir plus
		$this->installdir=",^/,";
		// $this->installdir=",^/spip/,";
		
		### 
		# Le chemin vers la page d'erreur au cas ou aucun filtre ne correspond
		$this->pagedestination="squelettes/404.html";
		
		# NE PLUS RIEN TOUCHER SOUS CETTE LIGNE pour les urls-propres-arbo
		##################################################################
		
		###
		# Les règles de redirection
		
		# Les mots-cles
		$this->regles[] = Array( 'filtre'       => ',^.*\+-[^/\.]+(-\+).html$,',
					'remplacement' => 'spip.php?page=mot' );
		# Les breves
		$this->regles[] = Array( 'filtre'       => ',^.*\+[^/\.]+\+.html$,',
					'remplacement' => 'spip.php?page=breve' );
		# les auteurs
		$this->regles[] = Array( 'filtre'       => ',^.*_[^/\.]+_.html$,',
					'remplacement' => 'spip.php?page=auteur' );
		# Les sites
		$this->regles[] = Array( 'filtre'       => ',^.*@[^/\.]+@.html$,',
					'remplacement' => 'spip.php?page=site' );
		# Les articles (en dernier car expression plus "large")
		$this->regles[] = Array( 'filtre'       => ',^(.*/)?[^/\.]+.html$,',
					'remplacement' => 'spip.php?page=article' );
		# Les rubriques
		$this->regles[] = Array( 'filtre'       => ',^((.*/)?[^/\.]+)?/?$,',
				'remplacement' => 'spip.php?page=rubrique' );
		
		
		# NE PLUS RIEN TOUCHER SOUS CETTE LIGNE
		###############################################################
		
		# L'url d'appel et ses variables
		$baseurl = preg_replace($this->installdir, '', $_SERVER['REQUEST_URI']);
		$this->getPageVars($baseurl, $this->url, $this->qsa );
		$this->filter();
	}
	
	function filter() {
		foreach ( $this->regles as $regle ) {
			if ( preg_match( $regle['filtre'], $this->url ) ) {
				$this->getPageVars( $regle['remplacement'], $this->pagedestination, $pagedestvars );
				$GLOBALS['_SERVER']['REDIRECT_url_propre'] = $this->url;
				$_GET                                     += $this->qsa + $pagedestvars;
				$_REQUEST                                 += $this->qsa + $pagedestvars;
				// On ré-enregistre les variable globales modifiées dans $GLOBALS
				foreach ($_GET as $cle => $val) 
					$GLOBALS[$cle] = $_GET[$cle];
				break;
			}
		}
	}
	
	function getPageVars($url, &$page, &$variables) {
		$variables = Array();
		$page      = $url;
		
		// On vérifie que l'url possède des variables (page?variables)
		if ( ereg( "(.*)\?(.*)", $url, $vars ) ) {
			// On récupère la page
			$page = $vars[1];
			
			// on récupére le bloc de variables
			$get = $vars[2];
			
			// on regarde si plusieurs variables sont définies (blocvar1&blocvar2)
			if ( ereg( "(.*)\&(.*)", $get, $vars ) ) {
				 // on supprime le $vars[0] qui correspond à $get
				array_shift($vars);
				
				foreach ($vars as $val) {
					// on regarde si ca correspond bien à une déf de var (var1=valeur)
					if ( ereg( "(.*)\=(.*)", $val, $var ) )
						$variables[$var[1]] = $var[2];
				}
			}
			// on regarde si au moins une variable est définie
			elseif (ereg("(.*)\=(.*)",$get,$var))
				$variables[$var[1]] = $var[2];
		}
	}
}

$spipR = new SpipRewriteWith404();
require $spipR->pagedestination;

?>